%global __libtoolize :
%global momorel 3
%global md5sum_src0 2c29ab90cc30aa3b92fbd78030ccc198

Summary: High-performance and highly configurable free RADIUS server.
Name: freeradius
Version: 1.1.6
Release: %{momorel}m%{?dist}
License: GPL
Group: System Environment/Daemons
URL: http://www.freeradius.org/
#ftp://ftp.freeradius.org/pub/radius/old/freeradius-1.1.5.tar.gz
%NoSource 0 ftp://ftp.freeradius.org/pub/radius/%{name}-%{version}.tar.bz2 %{md5sum_src0}
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: net-snmp krb5-libs net-snmp-utils
PreReq: chkconfig, shadow-utils
BuildRequires: pam-devel zlib-devel
BuildRequires: libtool libtool-ltdl-devel
BuildRequires: net-snmp-devel >= 5.4
BuildRequires: net-snmp-utils krb5-devel openssl-devel
BuildRequires: mysql-devel unixODBC-devel gdbm-devel
BuildRequires: postgresql-devel >= 8.2.3
BuildRequires: openldap-devel >= 2.3.19
BuildRequires: python >= 2.5
Patch1: freeradius-1.0.0-ltdl_no_la.patch
Patch3: freeradius-0.9.0-pam-multilib.patch
Patch4: freeradius-0.9.0-com_err.patch
Patch8: freeradius-1.0.0-samba3.patch
Patch10: freeradius-1.1.3-build.patch
Patch11: freeradius-1.1.2-no_sql_inc.patch
Patch12: freeradius-1.1.3-ldap.patch
Obsoletes: freeradius-ldap


%description
The FreeRADIUS Server Project is a high performance and highly configurable
GPL'd free RADIUS server. The server is similar in some respects to
Livingston's 2.0 server.  While FreeRADIUS started as a variant of the
Cistron RADIUS server, they don't share a lot in common any more. It now has
many more features than Cistron or Livingston, and is much more configurable.

FreeRADIUS is an Internet authentication daemon, which implements the RADIUS
protocol, as defined in RFC 2865 (and others). It allows Network Access
Servers (NAS boxes) to perform authentication for dial-up users. There are
also RADIUS clients available for Web servers, firewalls, Unix logins, and
more.  Using RADIUS allows authentication and authorization for a network to
be centralized, and minimizes the amount of re-configuration which has to be
done when adding or deleting new users.

%package mysql
Summary: MySQL bindings for freeradius
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: mysql

%description mysql
This plugin provides the MySQL bindings for the FreeRADIUS server project.

%package postgresql
Summary: postgresql bindings for freeradius
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: postgresql
Provides: freeradius-pgsql
Obsoletes: freeradius-pgsql

%description postgresql
This plugin provides the postgresql bindings for the FreeRADIUS server project.

%package unixODBC
Summary: unixODBC bindings for freeradius
Group: System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires: unixODBC
Provides: freeradius-unixodbc
Obsoletes: freeradius-unixodbc

%description unixODBC
This plugin provides the unixODBC bindings for the FreeRADIUS server project.


%prep
%setup -q
%patch1 -p1 -b .ltdl_no_la
%patch3 -p1 -b .pam-multilib
%patch4 -p1 -b .com_err
%patch8 -p1 -b .samba3
%patch10 -p1 -b .build
%patch11 -p1 -b .no_sql_inc
%patch12 -p1 -b .ldap


%build
%ifarch s390 s390x
export CFLAGS="$RPM_OPT_FLAGS -fPIC -DLDAP_DEPRECATED"
%else
export CFLAGS="$RPM_OPT_FLAGS -fpic -DLDAP_DEPRECATED"
%endif

# bad fix for libtool: clear buildroot early, set LDFLAGS to buildroot libdir
export LDFLAGS="-L${RPM_BUILD_ROOT}%{_libdir}"

%configure \
  --with-gnu-ld \
  --with-threads \
  --with-thread-pool \
  --disable-ltdl-install \
  --with-docdir=%{_docdir}/freeradius-%{version} \
  --with-rlm-sql_postgresql-include-dir=%{_includedir}/pgsql \
  --with-rlm-sql-postgresql-lib-dir=%{_libdir} \
  --with-rlm-sql_mysql-include-dir=%{_includedir}/mysql \
  --with-mysql-lib-dir=%{_libdir}/mysql \
  --with-unixodbc-lib-dir=%{_libdir} \
  --with-rlm-dbm-lib-dir=%{_libdir} \
  --with-rlm-krb5-include-dir=%{_includedir}
%if "%{_lib}" == "lib64"
perl -pi -e 's:sys_lib_search_path_spec=.*:sys_lib_search_path_spec="/lib64 /usr/lib64 /usr/local/lib64":' libtool
%endif

make

# remove '--disable-static' 2006-04-22
# version 1.1.1 specifically BUG
# see, http://bugs.freeradius.org/show_bug.cgi?id=350

%install
rm -rf --preserve-root %{buildroot}
mkdir -p %{buildroot}%{_sysconfdir}/{logrotate.d,pam.d,init.d}

# fix for bad libtool bug - can not rebuild dependent libs and bins
export LD_LIBRARY_PATH=$RPM_BUILD_ROOT/%{_libdir}
make install R=$RPM_BUILD_ROOT

RADDB=%{buildroot}%{_sysconfdir}/raddb
# set radiusd as default user/group
perl -i -pe 's/^#user =.*$/user = radiusd/' $RADDB/radiusd.conf
perl -i -pe 's/^#group =.*$/group = radiusd/' $RADDB/radiusd.conf
# shadow password file MUST be defined on Linux
perl -i -pe 's/#  shadow =/shadow =/' $RADDB/radiusd.conf

install -m 755 redhat/rc.radiusd-redhat %{buildroot}%{_initscriptdir}/radiusd
install -m 644 redhat/radiusd-logrotate %{buildroot}%{_sysconfdir}/logrotate.d/radiusd
install -m 644 redhat/radiusd-pam %{buildroot}%{_sysconfdir}/pam.d/radiusd

# remove unwanted rc.radiusd
rm -f %{buildroot}%{_sbindir}/rc.radiusd

find %{buildroot}%{_libdir} -name "*.la" -print | xargs rm -f
find %{buildroot}%{_libdir} -name "*.a" -print | xargs rm -f

mkdir -p %{buildroot}/var/log/radius
touch    %{buildroot}/var/log/radius/{radutmp,radwtmp,radius.log}
mkdir -p %{buildroot}/var/log/radius/radacct
mkdir -p %{buildroot}/var/run/radiusd

# remove unsupported config files
rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/raddb/oraclesql.conf
rm -f $RPM_BUILD_ROOT/%{_sysconfdir}/raddb/experimental.conf


%clean
rm -fr --preserve-root %{buildroot}


%pre
/usr/sbin/useradd -M -o -r -d / -u 95 -c "radiusd user" -s /bin/false radiusd > /dev/null 2>&1 || :


%post
/sbin/ldconfig
if [ $1 = 1 ]; then
  /sbin/chkconfig --add radiusd
fi
for i in /var/log/radius/{radutmp,radwtmp,radius.log}; do
  /bin/touch $i && /bin/chown radiusd: $i && /bin/chmod 600 $i
done


%preun
if [ $1 = 0 ]; then
  /sbin/service radiusd stop > /dev/null 2>&1
  /sbin/chkconfig --del radiusd
fi

%postun
if [ $1 -ge 1 ]; then
  /sbin/service radiusd condrestart >/dev/null 2>&1 || :
fi
/sbin/ldconfig


%files
%defattr(-,root,root,-)
%doc %{_docdir}/freeradius-%{version}/
%config (noreplace) %{_sysconfdir}/pam.d/radiusd
%config (noreplace) %{_sysconfdir}/logrotate.d/radiusd
%config (noreplace) %{_initscriptdir}/radiusd
#%%config (noreplace) %{_sysconfdir}/raddb/[a-ce-z]*
%config %{_sysconfdir}/raddb/dictionary*
%config (noreplace) %{_sysconfdir}/raddb/acct_users
%config (noreplace) %{_sysconfdir}/raddb/attrs
%config (noreplace) %{_sysconfdir}/raddb/certs
%config (noreplace) %{_sysconfdir}/raddb/clients
%config (noreplace) %{_sysconfdir}/raddb/clients.conf
%config (noreplace) %{_sysconfdir}/raddb/dictionary
%config (noreplace) %{_sysconfdir}/raddb/eap.conf
%config (noreplace) %{_sysconfdir}/raddb/example.pl
%config (noreplace) %{_sysconfdir}/raddb/hints
%config (noreplace) %{_sysconfdir}/raddb/huntgroups
%config (noreplace) %{_sysconfdir}/raddb/ldap.attrmap
%config (noreplace) %{_sysconfdir}/raddb/naslist
%config (noreplace) %{_sysconfdir}/raddb/naspasswd
%config (noreplace) %{_sysconfdir}/raddb/otp.conf
%config (noreplace) %{_sysconfdir}/raddb/preproxy_users
%config (noreplace) %{_sysconfdir}/raddb/proxy.conf
%config (noreplace) %{_sysconfdir}/raddb/radiusd.conf
%config (noreplace) %{_sysconfdir}/raddb/realms
%config (noreplace) %{_sysconfdir}/raddb/snmp.conf
%config (noreplace) %{_sysconfdir}/raddb/sqlippool.conf
%config (noreplace) %{_sysconfdir}/raddb/users
%{_bindir}/*
%{_libdir}/libeap*.so
%{_libdir}/libradius*.so
%{_libdir}/rlm_acct_unique*.so
%{_libdir}/rlm_always*.so
%{_libdir}/rlm_attr_filter*.so
%{_libdir}/rlm_attr_rewrite*.so
%{_libdir}/rlm_chap*.so
%{_libdir}/rlm_checkval*.so
%{_libdir}/rlm_counter*.so
#%%{_libdir}/rlm_dbm*.so
%{_libdir}/rlm_detail*.so
%{_libdir}/rlm_digest*.so
%{_libdir}/rlm_eap-*.so
%{_libdir}/rlm_eap.so
%{_libdir}/rlm_eap_gtc*.so
%{_libdir}/rlm_eap_leap*.so
%{_libdir}/rlm_eap_md5*.so
%{_libdir}/rlm_eap_mschapv2*.so
%{_libdir}/rlm_eap_peap*.so
%{_libdir}/rlm_eap_sim*.so
%{_libdir}/rlm_eap_tls*.so
%{_libdir}/rlm_eap_ttls*.so
%{_libdir}/rlm_exec*.so
%{_libdir}/rlm_expr*.so
%{_libdir}/rlm_fastusers*.so
%{_libdir}/rlm_files*.so
%{_libdir}/rlm_ippool*.so
%{_libdir}/rlm_krb5*.so
%{_libdir}/rlm_ldap*.so
%{_libdir}/rlm_mschap*.so
%{_libdir}/rlm_ns_mta_md5*.so
%{_libdir}/rlm_otp*.so
%{_libdir}/rlm_pam*.so
%{_libdir}/rlm_pap*.so
%{_libdir}/rlm_passwd*.so
%{_libdir}/rlm_perl*.so
%{_libdir}/rlm_preprocess*.so
%{_libdir}/rlm_radutmp*.so
%{_libdir}/rlm_realm*.so
%{_libdir}/rlm_sql-%{version}.so
%{_libdir}/rlm_sql.so
%{_libdir}/rlm_sqlcounter*.so
%{_libdir}/rlm_sql_log*.so
%{_libdir}/rlm_unix*.so
%{_datadir}/freeradius
%{_sbindir}/*
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%{_mandir}/man8/*.8*
%attr(0700,radiusd,radiusd) %dir /var/log/radius
%ghost %attr(0600,radiusd,radiusd) /var/log/radius/radutmp
%ghost %attr(0600,radiusd,radiusd) /var/log/radius/radwtmp
%ghost %attr(0600,radiusd,radiusd) /var/log/radius/radius.log
%attr(0700,radiusd,radiusd) %dir /var/log/radius/radacct
%attr(0700,radiusd,radiusd) %dir /var/run/radiusd

%files mysql
%defattr(-,root,root,-)
%{_sysconfdir}/raddb/sql.conf
%{_libdir}/*_mysql*.so

%files postgresql
%defattr(-,root,root,-)
%{_sysconfdir}/raddb/postgresql.conf
%{_libdir}/*_postgresql*.so


%files unixODBC
%defattr(-,root,root,-)
%{_sysconfdir}/raddb/mssql.conf
%{_libdir}/*_unixodbc*.so


%changelog
* Mon Jul 23 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.6.6-3m)
- move start up script from %%{_initrddir} to %%{_initscriptdir}

* Sat Jun 16 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.6.6-2m)
- rebuild against net-snmp

* Sun Jun  3 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.1.6-1m)
- [SECURITY] CVE-2007-2028
- sync FC-devel (freeradius-1.1.5-1)

* Thu May 24 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.1.1-7m)
- change Source URL

* Sun Mar 11 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.1.1-6m)
- rebuild against postgresql-8.2.3

* Tue Jan  2 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.1.1-5m)
- add BuildRequires: libtool-ltdl-devel

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.1.1-4m)
- rebuild against python-2.5

* Wed Aug  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.1-3m)
- rebuild against net-snmp 5.3.1.0

* Tue May 17 2006 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (1.1.1-1m)
- rebuild against mysql 5.0.22-1m

* Sun Apr 23 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.1.1-1m)
- [SECURITY] CVE-2006-1354 CVE-2005-1454 CVE-2005-1455
- http://www.freeradius.org/security.html
- add Patch10: freeradius-1.1.1-libradius_install.patch (from Gentoo)
-     Patch11: freeradius-1.1.1-versionless-la-files.patch (from Gentoo)
-     Patch12: freeradius-1.1.1-docdir.patch
- update Patch2: freeradius-1.1.1-libdir.patch
-        Patch5: freeradius-1.1.1-pie.patch
- remove Patch1: freeradius-1.0.0-ltdl_no_la.patch
-        Patch6: freeradius-0.9.3-gcc34.patch
-        Patch7: freeradius-1.0.2-sasl2.patch
- remove --disable-static option for specific BUG at version 1.1.1 
- add REMOVE.PLEASE

* Sun Apr  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.2-6m)
- rebuild against openldap-2.3.19

* Sat Jan 14 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.2-5m)
- rebuild against openldap-2.3.11

* Sat Nov 19 2005 Shigeyuki Yamashita <shige@momonga-linux.org>
- (1.0.2-4m)
- rebuild against postgresql-8.1.0

* Mon Sep  5 2005 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (1.0.2-3m)
- rebuild against for MySQL-4.1.14

* Mon Apr 25 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.2-2m)
- rebuild against postgresql-8.0.2.

* Thu Mar 10 2005 Kazuhiko <kazuhiko@fdiary.net>
- (1.0.2-1m)
- version up since 1.0.1 tarball moved to old/
- Provides and Obsoletes freeradius-pgsql
- Provides and Obsoletes freeradius-unixodbc

* Thu Mar 10 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.1-1m)
- sync with FC3. specopt is fully disabled.

* Tue Feb 15 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.9.3-7m)
- enable x86_64.

* Wed Oct 27 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (0.9.3-6m)
- add gcc34 patch

* Mon Aug 23 2004 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.9.3-5m)
  revised source url

* Sun Jul  4 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (0.9.3-4m)
- stop daemon

* Thu Apr  8 2004 Hiroyuki Koga <kuma@momonga-inux.org>
- (0.9.3-3m)
- correct comment out for _initscriptdir macro
- use %%NoSource and %%make
- add Prereq: chkconfig, initscripts

* Fri Mar 19 2004 Toru Hoshina <t@momonga-linux.org>
- (0.9.3-2m)
- revised spec for enabling rpm 4.2.
- add postgresql and unixodbc support packages.

* Mon Jan 26 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (0.9.3-1m)
- update to 0.9.3

* Tue Nov 18 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (0.9.1-3m)
- add BuildConflicts: db2-devel
- add patch to be compiled with gdbm-1.8.3(libgdbm_compat)
- fix install directory of README.rpm

* Mon Nov 10 2003 Kazuhiko <kazuhiko@fdiary.net>
- (0.9.1-2m)
- rebuild against gdbm-1.8.0-19m

* Mon Oct 14 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (0.9.1-1m)
- version 0.9.1

* Wed Sep  3 2003 YONEKAWA Susumu <yonekawa@mmg.roka.jp>
- (0.8.1-6m)
- rebuild against for MySQL-4.0.14-1m
- License: GPL
- BuildRoot: %{_tmppath}/%{name}-%{version}-root

* Thu Jun 19 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-5m)
  rebuild against cyrus-sasl2

* Thu Mar  6 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-4m)
  rebuild against openssl 0.9.7a

* Mon Feb 10 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (0.8.1-3m)
- rebuild against for gdbm

* Sun Feb  9 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.8.1-2m)
- %%install: rm -rf %{buildroot} before install

* Fri Feb  7 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (0.8.1-1m)
  update to 0.8.1

* Sun Jan 05 2003 Tadataka Yoshikawa <yosshy@momonga-linux.org>
- (0.7.1-2m)
- fix Source URI.

* Fri Nov 01 2002 YAMAGUCHI Kenji <yamk@momonga-linux.org>
- This RPM were created by Shawn K. O'Shea <pkg@eth0.net>
- get from http://volcano.boulderhill.net/freeradius-rpm/
- see http://volcano.boulderhill.net/freeradius-rpm/README.rpm.txt
- Momongized.
- NoSource.
- update to 0.7.1
- enable support mysql and ldap as default
